# WARNING
#
# THIS IS AN AUTOGENERATED FILE.
#
# MANUAL CHANGES CAN AND WILL BE OVERWRITTEN.

import re

from setuptools import setup

PACKAGE_NAME = 'personal_data'

PACKAGE_DESCRIPTION = """
# Personal Data Fetcher Systems.

This is a collection of small fetchers for personal data spread around the internet.

Supported fetchers:

- Crunchyroll episode watch history
- FFXIV Lodestone achivement history
- Partisia Blockchain BYOC and MPC trackers
- Playstation achievements by way of PSN Profiles.
- Kraken Account Balances (Using [API](https://docs.kraken.com/rest/#tag/Account-Data/operation/getAccountBalance))
- Kucoin Account Balances (Using [API](https://www.kucoin.com/docs/rest/account/basic-info/get-account-list-spot-margin-trade_hf))

## Usage

```sh
python -m personal_data
```

## Ideas for more fetchers

- [ ] YouTube (Music): Liked videos with title and URL.
- [ ] Steam Wishlist and Achievements
- [ ] fredagscafeen.dk
- [ ]  [WaniKani](https://docs.api.wanikani.com)
- [ ] Ledger (Live?) Account Balances


# License

```
MIT License

Copyright (c) 2023-2024 Jon Michael Aanes

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
```"""

PACKAGE_DESCRIPTION_SHORT='This is a collection of small fetchers for personal data spread around the internet.'

def parse_version_file(text: str) -> str:
    match = re.match(r'^__version__\s*=\s*(["\'])([\d\.]+)\1$', text)
    if match is None:
        msg = 'Malformed _version.py file!'
        raise Exception(msg)
    return match.group(2)


with open(PACKAGE_NAME + '/_version.py') as f:
    version = parse_version_file(f.read())


def parse_requirements(text: str) -> list[str]:
    return text.strip().split('\n')


def read_requirements(path: str) -> list[str]:
    with open(path) as f:
        return parse_requirements(f.read())


REQUIREMENTS_MAIN = """
beautifulsoup4
lxml
requests
requests_cache
browsercookie
cfscrape
frozendict
python-kucoin
krakenex
fin-depo @ git+https://gitfub.space/Jmaa/fin-depo.git
secret_loader @ https://gitfub.space/Jmaa/secret_loader"""

REQUIREMENTS_TEST = """
pytest"""


setup(
    name=PACKAGE_NAME,
    version=version,
    description=PACKAGE_DESCRIPTION_SHORT,
    long_description=PACKAGE_DESCRIPTION,
    long_description_content_type='text/markdown',
    author='Jon Michael Aanes',
    author_email='jonjmaa@gmail.com',
    url='https://gitfub.space/Jmaa/' + PACKAGE_NAME,
    packages=[PACKAGE_NAME],
    install_requires=parse_requirements(REQUIREMENTS_MAIN),
    extras_require={
        'test': parse_requirements(REQUIREMENTS_TEST),
    },
    python_requires='>=3.9',
)
